<?php
/* $Id: nc_comments.class.php 3921 2010-08-23 11:10:35Z denis $ */

class nc_comments {

  public $template, $last_updated;
  protected $core;
  private $_message_cc, $_current_catalogue, $_current_sub, $_parent_sub_tree, $_current_cc;
  private $_commentsData, $_mainArr, $_nestArr, $_showCommentsForm, $_showCommentsQuantity;
  private $_comment_rules, $_accessibilityAdd, $_accessibilityEdit, $_accessibilityDelete, $_accessibilitySubscribe;
  private $db, $_perm, $_accessibility, $_bbcodes;

  /**
   * Constructor function
   * @param `Sub_Class_ID` value
   */ 
  public function __construct ($message_cc) {
    global $MODULE_FOLDER, $DOCUMENT_ROOT;
    global $db, $nc_core, $perm, $AUTH_USER_ID, $ADMIN_PATH;
    global $current_catalogue, $current_sub, $parent_sub_tree, $current_cc;
    
    // system superior object
    if ( get_class($nc_core)=="nc_Core" ) $this->core = $nc_core;
    
    // start values
    $this->db = $db;
    $this->_perm = $perm;
    $this->AUTH_USER_ID = $AUTH_USER_ID;
    $this->_message_cc = (int)$message_cc;
    $this->MODULE_PATH = str_replace($DOCUMENT_ROOT, "", $MODULE_FOLDER)."comments/";
    $this->ADMIN_PATH = $ADMIN_PATH;
    $this->last_updated = time();
    // this may useful when get inherited cc settings
    $this->_current_catalogue = $current_catalogue;
    $this->_current_sub = $current_sub;
    $this->_parent_sub_tree = $parent_sub_tree;
    $this->_current_cc = $current_cc;
   
    // accessibility initialize, init only once because on action new object creating
    $this->_comment_rules = $this->_getInheritedRules();
  }
    
  
  /**
   * Get comments wall HTML text
   * @param `Message_ID` value
   * @param "from" value, start from N element
   * @param "quantity" value, how many comments display
   * @return comments wall HTML text
   */ 
  public function wall ($message_id, $template = 0, $from = 0, $quantity = -1) {
    global $AUTH_USER_ID, $MODULE_FOLDER ;
    // set parameters
    $this->_showCommentsFrom = (int)$from;
    $this->_showCommentsQuantity = (int)$quantity;
    // set internal comments arrays, lezy instantiation
    if ( !isset($this->_commentsData) ) {
      $this->loadArrays($message_id);
    }

    // start values
    $result = "";
    $message_id = (int)$message_id;
    $template = (int)$template;
    
    // refresh accessibility
    $this->_getAccessibility();
    // template
    $templateData = $this->_getTemplate($template);
    
    // возможность подписки
    $this->_accessibilitySubscribe = $this->_accessibilityAdd && $templateData['SubscribeAllow'] && $AUTH_USER_ID;
    if ( $this->_accessibilitySubscribe ) {
        require_once($MODULE_FOLDER."comments/nc_commsubs.class.php");
        $nc_commsubs = new nc_commsubs();
        $is_subscribe = $nc_commsubs->is_subscribe ( $AUTH_USER_ID, $this->_message_cc, $message_id );
    }
        
    if ( !empty($this->_commentsData) ) {
      // get comments wall
      $commentsBlock = $this->_sorting($message_id);
      // past comments
      foreach ($this->_commentsData AS $comment) {
        // past comment text
        $commentsBlock = str_replace("%COMMENT_".$this->_message_cc."_".$message_id."_".$comment['id']."%", nl2br($comment['Comment']), $commentsBlock);
        // bbcode processing
        if ($this->isBBcodes($template)) $commentsBlock = nc_bbcode($commentsBlock);
        // all comments ids to array for javascript
        $all_comments_id[] = $comment['id'];
      }
    }
    
    // phpjavascript class construct
    if ($this->_accessibilityAdd) {
      // demountable values in comment HTML forms
      $replaceKeys = array("%ISBBCODES");
      $replaceValues = array( $this->isBBcodes($template) );
      // this eval need to prefer localisation constants
      eval("\$addBlock = \"".str_replace($replaceKeys, $replaceValues, $templateData['Add_Block'])."\";");
      eval("\$editBlock = \"".str_replace($replaceKeys, $replaceValues, $templateData['Edit_Block'])."\";");
      eval("\$deleteBlock = \"".str_replace($replaceKeys, $replaceValues, $templateData['Delete_Block'])."\";");
      // compile initialize json "array"
      $json_parameters = "{
        'message_cc':'".$this->_message_cc."',
        'message_id':'".$message_id."',
        'template_id':'".$template."',
        'add_block':escape(\"".$this->commentValidateShow($addBlock, $template, 0, 1)."\"),
        'edit_block':escape(\"".$this->commentValidateShow($editBlock, $template, 0, 1)."\"),
        'delete_block':escape(\"".$this->commentValidateShow($deleteBlock, $template, 0, 1)."\"),
        'last_updated':'".$this->last_updated."',
        'MODULE_PATH':'".$this->MODULE_PATH."',
        'LOADING':'".NETCAT_MODULE_COMMENTS_ADD_FORM_LOADING_TEXT."',
        'SUBSCRIBE_TO_ALL':'".NETCAT_MODULE_COMMENTS_SUBSCRIBE_TO_ALL."',
        'UNSUBSCRIBE_FROM_ALL':'".NETCAT_MODULE_COMMENTS_UNSUBSCRIBE_FROM_ALL."',
        'edit_access':'".$this->_comment_rules['Edit_Rule']."',
        'delete_access':'".$this->_comment_rules['Delete_Rule']."',
        'all_comments_id':[".join(", ", (array)$all_comments_id)."]
      }";
      // load need scripts
      $result.= "<script src='".$this->MODULE_PATH."comments.js' type='text/javascript' language='JavaScript'></script>\r\n";
      if ($this->isBBcodes($template)) $result.= "<script language='JavaScript' type='text/javascript' src='".$this->ADMIN_PATH."js/bbcode.js'></script>\r\n";
      $result.= "<script type='text/javascript'>\r\n";
      $result.= "nc_commentsObj".$this->_message_cc."_".$message_id." = new nc_Comments(".$json_parameters.");\r\n";
      $result.= "</script>\r\n";
    }
    // prefix
    $demountable = array("%ID");
    $replacing = array("nc_commentID".$this->_message_cc."_".$message_id."_0");
    $result.= str_replace($demountable, $replacing, $templateData['Prefix']);
    
    // subscribe
     if ( $this->_accessibilitySubscribe ) {
        $demountable = array("%ACTION", "%ID", "%TEXT");
        $replacing = array("nc_commentsObj".$this->_message_cc."_".$message_id.".".( $is_subscribe  ? "Unsubscribe(0);" : "Subscribe(0);")." return false;",
                       "nc_comments_subscribe".$this->_message_cc."_".$message_id."_0",
                        $is_subscribe ? NETCAT_MODULE_COMMENTS_UNSUBSCRIBE_FROM_ALL : NETCAT_MODULE_COMMENTS_SUBSCRIBE_TO_ALL);         
        $result.= str_replace($demountable, $replacing, $templateData['Subscribe_Block']);
    }
    $result.= $commentsBlock;
    // comments link
    if ($this->_accessibilityAdd) {
      // demountable values in comment HTML text
      $demountable = array("%ID", "%ACTION", "%TEXT");
      // replacing values
      $replacing = array(
        "nc_commentsReply".$this->_message_cc."_".$message_id."_0",
        "nc_commentsObj".$this->_message_cc."_".$message_id.".Form(0); return false;",
        NETCAT_MODULE_COMMENTS_LINK_COMMENT
      );
      $result.= str_replace($demountable, $replacing, $templateData['Comment_Link']);
    }
    $result.= $templateData['Suffix'];
    
    // return comments wall HTML text
    return $result;
  }

  
  /**
   * Get comments and compile internal private arrays
   * _mainArr, _nestArr and last_comment_id value
   * @param `Message_ID` value
   * @return true if comments exist or false
   */  
  public function loadArrays ($message_id) {
    // start values
    $this->_mainArr = array();
    $this->_nestArr = array();
    $from = $this->_showCommentsFrom ? $this->_showCommentsFrom : 0;
    $quantity = $this->_showCommentsQuantity!==false ? $this->_showCommentsQuantity : -1;
    $message_id = (int)$message_id;
    // get comments data
    $this->_commentsData = $this->db->get_results("SELECT *, IF( UNIX_TIMESTAMP(`Updated`) > UNIX_TIMESTAMP(`Date`), UNIX_TIMESTAMP(`Updated`), UNIX_TIMESTAMP(`Date`) ) AS LastUpdated, UNIX_TIMESTAMP(`Date`) AS Date, UNIX_TIMESTAMP(`Updated`) AS Updated
      FROM `Comments_Text`
      WHERE `Sub_Class_ID` = '".$this->_message_cc."' AND `Message_ID` = '".$message_id."'
      ORDER BY `Date` ASC", ARRAY_A);
    // comments data sorting
    if ( !empty($this->_commentsData) ) {
      // count zero level comments
      $from_count = 0;
      // set "from" value
      if ($from < 1) $from = 1;
      // set "quantity" value
      if ($quantity < 0) $quantity = $this->db->num_rows;### - $from 
      // set arrays
      foreach ($this->_commentsData AS $value) {
        // if comment in zero level - count him
        if ($value['Parent_Comment_ID']==0) $from_count++;
        // if set limit - set only need values
        // if reply `Parent_Comment_ID` exist in _nestArr - append it too
        if ( $from <= $from_count && ($quantity > ($from_count - $from) ) || isset($this->_nestArr[ $value['Parent_Comment_ID'] ]) ) {
          $this->_mainArr[$value['Parent_Comment_ID']][] = $value;
          $this->_nestArr[$value['id']] = $value['Parent_Comment_ID'];
        }
        $this->last_updated = max($this->last_updated, $value['Updated']);
      }
      $result = true;
    }
    else {
      $result = false;
    }

    // return true or false
    return $result;
  }
    
  public function getCommentFromArray ($id = 0) {
    
    if ( empty($this->_commentsData) ) return false;
    
    if (!$id) return $this->_commentsData;
    
    foreach ($this->_commentsData AS $value) {
      if ($value['id']==$id) {
        $result = $value;
        break; 
      }
    }
    return $result ? $result : false;
  }
  
  /**
   * Get comment with children public method
   * @param `Message_ID` value
   * @param comment data
   * @param with children or not parameter
   * @return comment HTML text
   */
  public function getComment ($message_id, $data, $template_id = 0, $recurse = true, $eval = true) {
    // refresh accessibility
    $this->_getAccessibility($data['id']);
    // template
    $templateData = $this->_getTemplate($template_id);
    // for eval code set ezSQL variable
    if ($eval) $db = $this->db;
    // level for this comment
    $level = $this->_getNesting($data['id']);
    // demountable values in comment HTML text
    $replaceKeys = array("%ID", "%COMMENT", "%USER_ID", "%USER_NAME", "%DATE", "%UPDATED", "%REPLY_LINK", "%EDIT_LINK", "%DELETE_LINK", "%REPLY_BLOCK", "%LEVEL");
    // comment reply link
    $reply_link = "";
    if ($this->_accessibilityAdd) {
      // demountable values in comment HTML text
      $demountable = array("%ID", "%ACTION", "%TEXT");
      
      // replacing values for reply link
      $replacing = array(
        "nc_commentsReply".$this->_message_cc."_".$message_id."_".$data['id'],
        "nc_commentsObj".$this->_message_cc."_".$message_id.".Form(".$data['id']."); return false;",
        NETCAT_MODULE_COMMENTS_LINK_REPLY
      );
      $reply_link = str_replace($demountable, $replacing, $templateData['Reply_Link']);
    }  
    // replacing values for edit link
    $edit_link = "";
    if ($this->_accessibilityEdit) {
      $replacing = array(
        "nc_commentsEdit".$this->_message_cc."_".$message_id."_".$data['id'],
        "nc_commentsObj".$this->_message_cc."_".$message_id.".Form(".$data['id'].", 2); return false;",
        NETCAT_MODULE_COMMENTS_LINK_EDIT
      );
      $edit_link = str_replace($demountable, $replacing, $templateData['Edit_Link']);
    }
    
    // replacing values fordelete link
    $delete_link = "";
    if ($this->_accessibilityDelete) {
      $replacing = array(
        "nc_commentsDelete".$this->_message_cc."_".$message_id."_".$data['id'],
        "nc_commentsObj".$this->_message_cc."_".$message_id.".Form(".$data['id'].", -1); return false;",
        NETCAT_MODULE_COMMENTS_LINK_DELETE
      );
      $delete_link = str_replace($demountable, $replacing, $templateData['Delete_Link']);
    }

    // template
    $commentTemplate = $templateData[($data['Parent_Comment_ID'] ? 'Reply_Block' : 'Comment_Block')];
    
    // replacing values
    $replaceValues = array(
        "nc_commentID".$this->_message_cc."_".$message_id."_".$data['id'],
        "<span id='nc_commentText".$this->_message_cc."_".$message_id."_".$data['id']."'>%COMMENT_".$this->_message_cc."_".$message_id."_".$data['id']."%</span>", // comment or reply text eval is dangerous!
        $data['User_ID'],
        strstr($commentTemplate, "%USER_NAME") ? $this->db->get_var("SELECT `Login` FROM `User` WHERE `User_ID` = '".intval($data['User_ID'])."'") : "",
        $data['Date'],
        $data['Updated'],
        $reply_link,
        $edit_link,
        $delete_link,
        $recurse ? $this->_sorting($message_id, $data['id'], $template_id) : "",
        $level
      );
    // comment HTML text
    $commentHTMLText = str_replace($replaceKeys, $replaceValues, $commentTemplate);
    // eval this block without comment text
    if ($eval) eval ("\$commentHTMLText = \"".$commentHTMLText."\";");
    // return comment HTML text
    return $commentHTMLText;
  }
  

  /**
   * Recursive sorting private method
   * @param `Message_ID` value
   * @param `Parent_Comment_ID` from `Comments_Text`
   * @return comment HTML text
   */
  private function _sorting ($message_id, $pid = 0, $template_id = 0) {
    // get data for this comment
    if ( empty($this->_mainArr[$pid]) ) return;
    // walk on this subarray
    foreach ($this->_mainArr[$pid] AS $data) {
      // add comment to result string
      $result.= $this->getComment($message_id, $data, $template_id);
    }
    // return result
    return $result;
  }
  
  
  /**
   * Get nesting count private method
   * @param comment `id` in _nestArr from `Comments_Text`
   * @return counted value
   */
  private function _getNesting ($id) {
    // count nesting
    for ($count = 0; $id = $this->_nestArr[$id]; $count++);
    // return result value
    return $count;
  }
  
  
  /**
   * Get number of children for this comment
   * @param comment `id` value
   * @return array of children or false
   */
  public function getChildren ($id) {
    // validate
    $id = (int)$id;
    // get children from base (only with `Parent_Comment_ID`, level + 1)
    $result = $this->db->get_col("SELECT `id` FROM `Comments_Text` WHERE `Parent_Comment_ID` = '".(int)$id."'");
    // return result
    return !empty($result) ? $result : false;
  }
  
  
  /**
   * Append new comment into the base
   * @param `Message_ID` value
   * @param `Parent_Message_ID` value
   * @param `Comment` comment text value
   * @param `User_ID` authorized user id
   * @return inserted value
   */
  public function addComment ($message, $parent_message, $comment, $user = 0) {
    // refresh accessibility
    $this->_getAccessibility();
    // clear HTML tags
    $comment = strip_tags($comment);
    // check accessibility
    if (!$this->_accessibilityAdd) {
      throw new Exception (NETCAT_MODULE_COMMENTS_NO_ACCESS);
    }
    // check other parameters
    if (
      !is_numeric($message) ||
      !is_numeric($parent_message) ||
      !$comment ||
      ( $user && !is_numeric($user) )
    ) {
      throw new Exception (NETCAT_MODULE_COMMENTS_UNCORRECT_DATA);
    }
    // append comments into the base
    $this->db->query("INSERT INTO `Comments_Text`
      (`Parent_Comment_ID`, `Sub_Class_ID`, `Message_ID`, `Date`, `Comment`, `User_ID`)
      VALUES
      ('".$parent_message."', '".$this->_message_cc."', '".$message."', NOW(), '".$this->db->escape($comment)."', '".$user."')");
    // inserted comment id
    $result = $this->db->insert_id;
    // refresh
    $this->loadArrays($message);
    // refresh count for this comment
    if ($result) $this->refreshCount($message, $parent_message);
    
    $cc_data = $this->core->sub_class->get_by_id($this->_message_cc);
    
    $this->core->event->execute("addComment", $cc_data['Catalogue_ID'], $cc_data['Subdivision_ID'], $cc_data['Sub_Class_ID'], $cc_data['Class_ID'], $message, $result);
    
    // clear cache if module exist
    if ( $this->core->modules->get_by_keyword('cache') ) {
      // get cache objects
      $nc_cache_full = nc_cache_full::getObject();
      $nc_cache_list = nc_cache_list::getObject();
      // clear cache
      $nc_cache_full->dropMessageCache($cc_data['Catalogue_ID'], $cc_data['Subdivision_ID'], $cc_data['Sub_Class_ID'], $cc_data['Class_ID'], $message);
      $nc_cache_list->dropSubClassCache($cc_data['Catalogue_ID'], $cc_data['Subdivision_ID'], $this->_message_cc);
    }
    // return  inserted comment id
    return $result;
  }
  
  /**
   * Update exist comment into the base
   * @param `id` comment id value
   * @param `Comment` comment text value
   * @param `User_ID` authorized user id
   * @return true or false
   */
  public function updateComment ($id, $comment, $user = 0) {
    // refresh accessibility
    $this->_getAccessibility($id);
    // clear HTML tags
    $comment = strip_tags($comment);
    // check accessibility
    if (!$this->_accessibilityEdit) {
      throw new Exception (NETCAT_MODULE_COMMENTS_NO_ACCESS);
    }
    // check other parameters
    if (
      !is_numeric($id) ||
      !$comment
      //|| ( $user && !is_numeric($user) )
    ) {
      throw new Exception (NETCAT_MODULE_COMMENTS_UNCORRECT_DATA);
    }
    
    // append comments into the base and return result
    $this->db->query("UPDATE `Comments_Text`
      SET `Comment` = '".$this->db->escape($comment)."',
        `Updated` = NOW()
      WHERE `id` = '".(int)$id."'"); //`User_ID` = '".$user."'
    
    $message_id = $this->db->get_var("SELECT `Message_ID` FROM `Comments_Text` WHERE `id` = '".$id."'");
    
    $result = $this->db->affected_rows;
    
    $cc_data = $this->core->sub_class->get_by_id($this->_message_cc);
    $this->core->event->execute("updateComment", $cc_data['Catalogue_ID'], $cc_data['Subdivision_ID'], $cc_data['Sub_Class_ID'], $cc_data['Class_ID'], $message_id, $id);
    
    // refresh arrays
    foreach ($this->_commentsData AS $comment) {
      if ($comment['id']==$id) {
        $this->loadArrays($comment['Message_ID']);
        break;
      }
    }
    
    // clear cache if module exist
    if ( $this->core->modules->get_by_keyword('cache') && $comment['Message_ID'] ) {
      // get cache objects
      $nc_cache_full = nc_cache_full::getObject();
      $nc_cache_list = nc_cache_list::getObject();
      // clear cache
      $nc_cache_full->dropMessageCache($cc_data['Catalogue_ID'], $cc_data['Subdivision_ID'], $cc_data['Sub_Class_ID'], $cc_data['Class_ID'], $comment['Message_ID']);
      $nc_cache_list->dropSubClassCache($cc_data['Catalogue_ID'], $cc_data['Subdivision_ID'], $this->_message_cc);
    }
    
    return $result;
  }
  
  
  /**
   * Delete comment from the base
   * @param `id` comment id value
   * @return true or false
   */
  public function deleteComment ($id) {
    // save deleting ids in this array
    static $accessibilityDeleteArray;
    // refresh accessibility
    if ( empty($accessibilityDeleteArray) ) {
      $this->_getAccessibility($id);
      $accessibilityDeleteArray = array();
    }
    // check accessibility
    if (!$this->_accessibilityDelete) {
      throw new Exception (NETCAT_MODULE_COMMENTS_NO_ACCESS);
    }
    // check other parameters
    if (
      !is_numeric($id)
    ) {
      throw new Exception (NETCAT_MODULE_COMMENTS_UNCORRECT_DATA);
    }

    // get data for this comment
    $comment_data = $this->db->get_row("SELECT `Message_ID`, `Parent_Comment_ID`
      FROM `Comments_Text` WHERE `id` = '".(int)$id."'", ARRAY_A);
      
    $this->db->query("UPDATE `Comments_Text` SET `Updated` = NOW() WHERE `id` = '".(int)$comment_data['Parent_Comment_ID']."'");
      
    $message_id = $this->db->get_var("SELECT `Message_ID` FROM `Comments_Text` WHERE `id` = '".$id."'");
    // delete comment from base
    $this->db->query("DELETE FROM `Comments_Text` WHERE `id` = '".(int)$id."'");
    
    $cc_data = $this->core->sub_class->get_by_id($this->_message_cc);
    
    $this->core->event->execute("dropComment", $cc_data['Catalogue_ID'], $cc_data['Subdivision_ID'], $cc_data['Sub_Class_ID'], $cc_data['Class_ID'], $message_id, $id);
    
    
    // this allow delete children with other `User_ID`
    array_push($accessibilityDeleteArray, $id);
    
    // update count value
    $this->refreshCount($comment_data['Message_ID'], $comment_data['Parent_Comment_ID'], "-");
    
    // get children
    $childrenExist = $this->getChildren($id);
    // if comments with children - drop recursive
    if ( !empty($childrenExist) ) {
      foreach ($childrenExist AS $child_comment_id) {
        $this->deleteComment($child_comment_id);
      }
    }
    
    // pop value from temp array
    array_pop($accessibilityDeleteArray);
    
    // refresh arrays
    if ( !empty($this->_commentsData) ) {
      foreach ($this->_commentsData AS $comment) {
        if ($comment['id']==$id) {
          $this->loadArrays($comment['Message_ID']);
          break;
        }
      }
    }
    
    // clear cache if module exist
    if ( $this->core->modules->get_by_keyword('cache') && $comment['Message_ID'] ) {
      // get cache objects
      $nc_cache_full = nc_cache_full::getObject();
      $nc_cache_list = nc_cache_list::getObject();
      // clear cache
      $nc_cache_full->dropMessageCache($cc_data['Catalogue_ID'], $cc_data['Subdivision_ID'], $cc_data['Sub_Class_ID'], $cc_data['Class_ID'], $comment['Message_ID']);
      $nc_cache_list->dropSubClassCache($cc_data['Catalogue_ID'], $cc_data['Subdivision_ID'], $this->_message_cc);
    }
    
    // return result
    return true;
  }
  
   
  /**
   * Validate comment text
   * 
   * @param string comment text
   * @param int template id
   * @param bool strip uncorrect tags
   * @param bool clear new line symbols
   *
   * @return string validated comment text
   */
  public function commentValidateShow ($comment, $template, $strip = true, $clear = false) {
    // check magic quotes
    if ( get_magic_quotes_gpc() ) {
      $value = stripslashes($comment);
    }
    // strip uncorrect tags
    if ($strip) {
      // clear HTML tags
      if ($this->isBBcodes($template)) {
        $comment = strip_tags($comment, "<div><b><i><u><img><span><a><br><br/>");
      }
      else {
        $comment = strip_tags($comment);
      }
    }
    // drop new line symbols
    if ($clear) $comment = str_replace( array("\r", "\n"), "", $comment );
    // return slashed result
    return addslashes($comment);
  }
  
  
  /**
   * Refresh `Count` value in `Comments_Count`
   * @param `Message_ID` value
   * @param `Parent_Comment_ID` value
   * @return true if executed or false
   */
  private function refreshCount ($message, $parent = 0, $sign = "+") {
    // validate
    $message = (int)$message;
    if (
      !in_array( $sign, array("+", "-") )
    ) {
      throw new Exception (NETCAT_MODULE_COMMENTS_UNCORRECT_DATA);
    }
    // check existion
    $exist = $this->db->get_var("SELECT `id` FROM `Comments_Count`
      WHERE `Sub_Class_ID` = '".$this->_message_cc."' AND `Message_ID` = '".$message."'");
    // insert or update count  
    if ($exist) {
      // comment or reply
      $suffix = $parent ? "Replies" : "Comments";
      // query
      $result = $this->db->query("UPDATE `Comments_Count`
        SET `Count".$suffix."` = `Count".$suffix."` ".$sign." 1
        WHERE `Sub_Class_ID` = '".$this->_message_cc."' AND `Message_ID` = '".$message."'");
    }
    else {
      if ($sign != "-") {
        $result = $this->db->query("INSERT INTO `Comments_Count`
          (`Sub_Class_ID`, `Message_ID`, `CountComments`)
          VALUES
          ('".$this->_message_cc."', '".$message."', 1)");
      }
    }
    // return result
    return $result;
  }
  
  
  /**
   * Get comments count public method
   * @param `Message_ID`
   * @param 0 - count comments and replies, 1 - only comments, 2 - only replies
   * @return counted value
   */
  public function count ($message_id, $selector = 0) {
    // validate value
    $message_id = (int)$message_id;
    // selector
    switch ($selector) {
      case 1:
        $query_str = "`CountComments`";
      break;
      case 2:
        $query_str = "`CountReplies`";
      break;
      default:
        $query_str = "ROUND(`CountComments` + `CountReplies`)";
    }
    // query
    $result = $this->db->get_var("SELECT ".$query_str." FROM `Comments_Count`
      WHERE `Sub_Class_ID` = '".$this->_message_cc."' AND `Message_ID` = '".$message_id."'");
    // return result
    return intval($result);
  }

  public function isRightsToSubscribe () {
    $this->_getAccessibility();
    return $this->_accessibilityAdd;
  }
  
  /**
   * Static function, returns rule ID by `Catalogue_ID` and `Catalogue_Type`
   * @param link to ezSQL object
   * @param `Catalogue_ID` if set `Catalogue_Type` (second parameter), or direct rule id
   * @param `Catalogue_Type`, value in array("Catalogue", "Subdivision", "Sub_Class")
   * @return rule id if exist
   */
  static function getRuleData (&$db, $id) {
    if (
      !is_object($db) ||
      !is_array($id)
    ) {
      throw new Exception (NETCAT_MODULE_COMMENTS_UNCORRECT_DATA);
    }
    // get args
    $id = array_map("intval", $id);
    $id = array_pad($id, 3, 0);
    list ($catalogue, $sub, $cc) = $id;
    // where string
    $where_str = "`Catalogue_ID` = '".$catalogue."'";
    $where_str.= " AND ".($sub ? "`Subdivision_ID` = '".$sub."'" : "NOT `Subdivision_ID`");
    $where_str.= " AND ".($cc ? "`Sub_Class_ID` = '".$cc."'" : "NOT `Sub_Class_ID`");
    // drop comment rule from base and return result
    return $db->get_row("SELECT * FROM `Comments_Rules` WHERE ".$where_str, ARRAY_A);
  }
  
  public function getEditRule () {
    return $this->_comment_rules['Edit_Rule'];
  }
  
  public function getDeleteRule () {
    return $this->_comment_rules['Delete_Rule'];
  }
  
  public function isBBcodes ($template) {
      // template
      $data = $this->_getTemplate($template);
      // return 1 or 0
      return $data['BBcodes'] ? 1 : 0;
  }
  
  public function isModerator () {
    // check for moderation
    if ( is_object($this->_perm) && $this->_message_cc ) {
      return $this->_perm->isSubClass($this->_message_cc, MASK_MODERATE);
    }
    // false
    return false;
  }


  public function getMailTemplate ( $id ) {
    $res = $this->_getTemplate($id);
    return $res['Mail_Template'];
  }

  public function getMailSubject( $id ) {
    $res = $this->_getTemplate($id);
    return $res['Mail_Subject'];
  }
  /**
   * Static function, append rule into the base
   * @param link to ezSQL object
   * @param `Catalogue_ID` if set `Catalogue_Type` (second parameter), or direct rule id
   * @param `Catalogue_Type`, value in array("Catalogue", "Subdivision", "Sub_Class")
   * @param `Access_ID` value in array(1, 2, 3)
   * @param `Edit_Rule` value in array("disable", "enable", "unreplied")
   * @param `Delete_Rule` value in array("disable", "enable", "unreplied")
   * @return inserted rule id
   */
  static function addRule (&$db, $id, $access, $edit, $delete) {
    if (
      !is_object($db) ||
      !is_array($id) ||
      !in_array($access, array(1, 2, 3, 4) ) ||
      !in_array( $edit, array("disable", "enable", "unreplied") ) ||
      !in_array( $delete, array("disable", "enable", "unreplied") )
    ) {
      throw new Exception (NETCAT_MODULE_COMMENTS_UNCORRECT_DATA);
    }
    // get args
    $id = array_map("intval", $id);
    $id = array_pad($id, 3, 0);
    list ($catalogue, $sub, $cc) = $id;
    // add comment relation
    $db->query("INSERT INTO `Comments_Rules`
    (`Catalogue_ID`, `Subdivision_ID`, `Sub_Class_ID`, `Access_ID`, `Edit_Rule`, `Delete_Rule`)
    VALUES
    ('".$catalogue."', '".$sub."', '".$cc."', '".$access."', '".$edit."', '".$delete."')");
    // return result
    return $db->insert_id;
  }
  
  /**
   * Static function, update rule into the base
   * @param link to ezSQL object
   * @param `Catalogue_ID` if set `Catalogue_Type` (second parameter), or direct rule id
   * @param `Catalogue_Type`, value in array("Catalogue", "Subdivision", "Sub_Class")
   * @param `Access_ID` value in array(1, 2, 3)
   * @param `Edit_Rule` value in array("disable", "enable", "unreplied")
   * @param `Delete_Rule` value in array("disable", "enable", "unreplied")
   * @return true if executable or false
   */
  static function updateRule (&$db, $id, $access, $edit, $delete) {
    if (
      !is_object($db) ||
      !is_array($id) ||
      !in_array($access, array(1, 2, 3, 4) ) ||
      !in_array( $edit, array("disable", "enable", "unreplied") ) ||
      !in_array( $delete, array("disable", "enable", "unreplied") )
    ) {
      throw new Exception (NETCAT_MODULE_COMMENTS_UNCORRECT_DATA);
    }
    // get args
    $id = array_map("intval", $id);
    $id = array_pad($id, 3, 0);
    list ($catalogue, $sub, $cc) = $id;
    // where string
    $where_str = "`Catalogue_ID` = '".$catalogue."'";
    $where_str.= " AND ".($sub ? "`Subdivision_ID` = '".$sub."'" : "NOT `Subdivision_ID`");
    $where_str.= " AND ".($cc ? "`Sub_Class_ID` = '".$cc."'" : "NOT `Sub_Class_ID`");
    // drop comment rule from base and return result
    return $db->query("UPDATE `Comments_Rules` SET
        `Access_ID` = '".$access."',
        `Edit_Rule` = '".$edit."',
        `Delete_Rule` = '".$delete."'
      WHERE ".$where_str);
  }
  
  /**
   * Static function, delete rule from the base
   * call static dropComments function with similar parameter
   * @param link to ezSQL object
   * @param mixed `Catalogue_ID` if set `Catalogue_Type` (second parameter), or direct rule id
   * @param `Catalogue_Type`, value in array("Catalogue", "Subdivision", "Sub_Class")
   * @return true if executable or false
   */

  static function dropRule (&$db, $id) {
    if (
      !is_object($db) ||
      !is_array($id)
    ) {
      throw new Exception (NETCAT_MODULE_COMMENTS_UNCORRECT_DATA);
    }
    // get args
    $id = array_map("intval", $id);
    $id = array_pad($id, 3, 0);
    list ($catalogue, $sub, $cc) = $id;
    // where string
    $where_str = "`Catalogue_ID` = '".$catalogue."'";
    $where_str.= " AND ".($sub ? "`Subdivision_ID` = '".$sub."'" : "NOT `Subdivision_ID`");
    $where_str.= " AND ".($cc ? "`Sub_Class_ID` = '".$cc."'" : "NOT `Sub_Class_ID`");
    // drop comment rule from base and return result
    $db->query("DELETE FROM `Comments_Rules` WHERE ".$where_str);
  }
  
  static function dropRuleCatalogue (&$db, $id) {
    if (
      !is_object($db) ||
      !( is_numeric($id) || is_array($id) )
    ) {
      throw new Exception (NETCAT_MODULE_COMMENTS_UNCORRECT_DATA);
    }
    // where string
    if ( is_array($id) ) {
      $id = array_map("intval", $id);
      $where_str = "`Catalogue_ID` IN (".join(", ", $id).") AND `Subdivision_ID` = 0 AND `Sub_Class_ID` = 0";
    }
    else {
      $where_str = "`Catalogue_ID` = '".$id."' AND `Subdivision_ID` = 0 AND `Sub_Class_ID` = 0";
    }
    // drop comment rule from base and return result
    $db->query("DELETE FROM `Comments_Rules` WHERE ".$where_str);
  }
  
  static function dropRuleSubdivision (&$db, $id) {
    if (
      !is_object($db) ||
      !( is_numeric($id) || is_array($id) )
    ) {
      throw new Exception (NETCAT_MODULE_COMMENTS_UNCORRECT_DATA);
    }
    // where string
    if ( is_array($id) ) {
      $id = array_map("intval", $id);
      $where_str = "`Subdivision_ID` IN (".join(", ",$id).") AND `Sub_Class_ID` = 0";
    }
    else {
      $where_str = "`Subdivision_ID` = '".$id."' AND `Sub_Class_ID` = 0";
    }
    // drop comment rule from base and return result
    $db->query("DELETE FROM `Comments_Rules` WHERE ".$where_str);
  }
  
  static function dropRuleSubClass (&$db, $id) {
    if (
      !is_object($db) ||
      !( is_numeric($id) || is_array($id) )
    ) {
      throw new Exception (NETCAT_MODULE_COMMENTS_UNCORRECT_DATA);
    }
    // where string
    if ( is_array($id) ) {
      $id = array_map("intval", $id);
      $where_str = "`Sub_Class_ID` IN (".join(", ",$id).")";
    }
    else {
      $where_str = "`Sub_Class_ID` = '".$id."'";
    }
    // drop comment rule from base and return result
    $db->query("DELETE FROM `Comments_Rules` WHERE ".$where_str);
  }
  
  /**
   * Static function, delete comments and their counted values from the base
   * @param link to ezSQL object
   * @param mixed `Catalogue_ID` if set `Catalogue_Type` (second parameter), or direct rule id
   * @param `Catalogue_Type`, value in array("Catalogue", "Subdivision", "Sub_Class")
   * @param mixed `Message_ID` value(s)
   * @return true if executable or false
   */
  static function dropComments (&$db, $id, $type, $message = 0) {
    if (
      !is_object($db) ||
      !( is_numeric($id) || is_array($id) ) ||
      !in_array( $type, array("Catalogue", "Subdivision", "Sub_Class") ) ||
      !( is_numeric($message) || is_array($message) )
    ) {
      throw new Exception (NETCAT_MODULE_COMMENTS_UNCORRECT_DATA);
    }
    // `Sub_Class_ID`
    if ( is_array($id) ) {
      $id = array_map("intval", $id);
      $sub_class_arr = $db->get_col("SELECT `Sub_Class_ID` FROM `Sub_Class` WHERE `".$type."_ID` IN (".join(", ", $id).")");
    }
    else {
      $sub_class_arr = $db->get_col("SELECT `Sub_Class_ID` FROM `Sub_Class` WHERE `".$type."_ID` = '".$id."'");
    }
    
    // where string
    if ( !empty($sub_class_arr) ) {
      $where_str = "`Comments_Text`.`Sub_Class_ID` IN (".join(", ", $sub_class_arr).")";
    }
    
    // `Message_ID`, where string
    if ( is_array($message) && !empty($message) ) {
      $message = array_map("intval", $message);
      $where_str.= ($where_str ? " AND " : "")."`Comments_Text`.`Message_ID` IN (".join(", ", $message).")";
    }
    else {
      $where_str.= $message > 0 ? ($where_str ? " AND " : "")."`Comments_Text`.`Message_ID` = '".$message."'" : "";
    }
    
    // drop comment rule from base and return result
    if ($where_str) {
      $result = $db->query("DELETE `Comments_Text`, `Comments_Count`
        FROM `Comments_Text` INNER JOIN `Comments_Count`
        WHERE `Comments_Text`.`Sub_Class_ID` = `Comments_Count`.`Sub_Class_ID`
          AND `Comments_Text`.`Message_ID` = `Comments_Count`.`Message_ID`
          AND ".$where_str);
    }
    // return result
    return $result ? $result : false;
  }
  

  private function _getTemplate ($id = 0) {
    // all templates
    static $TemplatesData = array();
    // get all data once from base
    if ( empty($TemplatesData) ) {
      $TemplatesData = $this->db->get_results("SELECT * FROM `Comments_Settings`", ARRAY_A);
    }
    // return if no result
    if ( empty($TemplatesData) ) return false;
    // walk
    foreach ($TemplatesData AS $value) {
      if ($value['Default']) $default = $value;
      if ($value['ID']!=$id) continue;
      $settings = $value;
    }
    // if no comparison set default
    if ( empty($settings) && !empty($default) ) $settings = $default;
    // if no default set first in array
    if ( empty($settings) ) $settings = $TemplatesData[0];
    // set BBcodes flag
    $this->_bbcodes = $settings['BBcodes'];
    // return result array
    return $settings;
  }
  
  
  /**
   * Accessibility check function
   * set internal class object access variables for current cc
   * @return true or false
   */
  private function _getInheritedRules () {
    static $cc_rules = array();
    
    // moderation freedom
    if ( $this->isModerator() ) {
      // for moderators
      // access - registered, edit - enable, delete - enable
      return array(
        'Access_ID' => 2,
        'Edit_Rule' => 'enable',
        'Delete_Rule' => 'enable'
      );
    }
    
    // got result in static array
    if ( isset($cc_rules[$this->_message_cc]) ) return $cc_rules[$this->_message_cc];
    
    // get result from global arrays
    if ( $this->_current_cc['Sub_Class_ID']==$this->_message_cc ) {
      $comment_rule_id = $this->_current_cc['Comment_Rule_ID'];
      if (!$comment_rule_id) {
        $comment_rule_id = $this->_current_sub['Comment_Rule_ID'];
      }
      $i = 0;
      while (!$comment_rule_id) {
        if ( empty($this->_parent_sub_tree[$i]) ) break;
        $comment_rule_id = $this->_parent_sub_tree[$i]['Comment_Rule_ID'];
        $i++;
      }
    }
  
    if (!$comment_rule_id) {
      // get from cc
      list($comment_rule_id, $sub_id, $cat_id) = $this->db->get_row("SELECT `Comment_Rule_ID`, `Subdivision_ID`, `Catalogue_ID` FROM `Sub_Class` WHERE `Sub_Class_ID` = '".$this->_message_cc."'", ARRAY_N);
    }
    
    if (!$comment_rule_id) {
      // walk top
      while (!$comment_rule_id) {
        // get from sub
        list($comment_rule_id, $parent_sub_id) = $this->db->get_row("SELECT `Comment_Rule_ID`, `Parent_Sub_ID` FROM `Subdivision` WHERE `Subdivision_ID` = '".$sub_id."'", ARRAY_N);
        // got result or root subdivision node
        if ($comment_rule_id || $parent_sub_id==0) break;
        // for next iteration
        $sub_id = $parent_sub_id;
      }
    }
    
    if (!$comment_rule_id) {
      // get from catalogue
      $comment_rule_id = $this->db->get_var("SELECT `Comment_Rule_ID` FROM `Catalogue` WHERE `Catalogue_ID` = '".$cat_id."'");
    }

    // get rule data
    $comment_permissions = $this->db->get_row("SELECT `Access_ID`, `Edit_Rule`, `Delete_Rule` FROM `Comments_Rules` WHERE `ID` = '".$comment_rule_id."'", ARRAY_A);

    $result = !empty($comment_permissions) ? $comment_permissions : false;

    // to static array
    $cc_rules[$this->_message_cc] = $result;
    
    // return true if set array or false
    return $result;
  }
  
  
  private function _getAccessibility ($id = 0) {
    // start values
    $this->_accessibilityAdd = false;
    $this->_accessibilityEdit = false; 
    $this->_accessibilityDelete = false;
    
    // moderation freedom
    if ( $this->isModerator() ) {
      $this->_accessibilityAdd = true;
      $this->_accessibilityEdit = true; 
      $this->_accessibilityDelete = true;
      return;
    }
    
    if ( empty($this->_comment_rules) ) return;
    
    // check add access
    switch ($this->_comment_rules['Access_ID']) {
      // 1 - all
      case 1:
        $this->_accessibilityAdd = true;
      break;
      // 2 - authorized
      case 2:
        if ($this->AUTH_USER_ID) $this->_accessibilityAdd = true;
      break;
      // 3 - permitted
      case 3:
        if ( CheckUserRights($this->_message_cc, 'comment', 1) ) $this->_accessibilityAdd = true;
      break;
      // 4 - nobody
    }
    
    if (!$id) return;
    
    // check edit and delete access
    if ( !empty($this->_commentsData) ) {
      foreach ($this->_commentsData AS $comment) {
        if ($comment['id']==$id) break;
      }
      // check
      switch ($this->_comment_rules['Access_ID']) {
        // 1 - all
        case 1:
        // 2 - authorized
        case 2:
          if ($this->AUTH_USER_ID!=0 && $this->AUTH_USER_ID==$comment['User_ID']) {
            $this->_accessibilityEdit = true; 
            $this->_accessibilityDelete = true;
          }
        break;
        // 3 - permitted
        case 3:
          if ( CheckUserRights($this->_message_cc, 'comment', 1) && $this->AUTH_USER_ID==$comment['User_ID'] ) {
            $this->_accessibilityEdit = true; 
            $this->_accessibilityDelete = true;
          }
        break;
        // 4 - nobody
      }
    }
    
    // check children
    $childrenExist = $this->getChildren($id);
    // eidt accessibility
    if ($this->_comment_rules['Edit_Rule']=="disable") $this->_accessibilityEdit = false;
    if ($this->_comment_rules['Edit_Rule']=="unreplied" && $childrenExist) $this->_accessibilityEdit = false;
    // delete accessibility
    if ($this->_comment_rules['Delete_Rule']=="disable") $this->_accessibilityDelete = false;
    if ($this->_comment_rules['Delete_Rule']=="unreplied" && $childrenExist) $this->_accessibilityDelete = false;
  
  }
  
}
?>
